#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n,m,c,out=0;
    scanf("%lld%lld",&n,&m);

    long long a[n+5],b[m+50];
    a[0]=b[0]=0;

    for(long long i=1; i<=m; i++)
    {
        scanf("%lld",&b[i]);
    }

    scanf("%lld",&c);

    for(long long i=1; i<=n; i++)
    {
        a[i]=i;
    }

    for (long long i=0;i<=n-m;i++)
    {
        for(long long j=1;j<=m;j++)
        {
            a[i+b[j]]=a[i+j];
        }
    }

    for (long long i=1; i<=n; i++)
    {
        out+=a[i]*pow(c,i);
    }

    printf("%lld",out%998244353);

    return 0;
}